CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  rxpin = 31 ' Receive on I/O pin 1 <- black from master black txpin p1 
  txpin = 30 ' Transmit on I/O pin 0 -> red to master red rxpin p0
  ServoCh1 = 16  'Pan                            
  ServoCh2 = 20  'Tilt
  ServoCh3 = 0   'Steering servo
  MotorChA = 7
  
   
VAR
  LONG SerStack[32]
  LONG Drivestack[4]
  LONG InitStack[4]
  LONG txVal_1, txVal_2, txVal_3, txVal_4 ' transmit
  LONG rxVal_1, rxVal_2, rxVal_3, rxVal_4 ' receive from master and PST
  LONG rxVal
  LONG rxHeight 
  LONG rxWidth 
  LONG rxTurretL 
  LONG rxTurretR
  LONG rxSteerL
  LONG rxSteerR
  LONG rxDriveF
  LONG rxDriveR

OBJ

  serial : "FullDuplexSerial"   ' "Extended_FDSerial" '' 
  f : "Float32Full" 
  SERVO : "Servo32v7.spin"
  
PUB Main | DutyCycle, temp,GetData' new stuff DutyCycle

   
  SERVO.Start
  SERVO.Ramp
  InitA
  serial.start(rxpin,txpin,%0000, 115200)          '- rxpin,txpin,mode,Baud
  Cognew(GetSer,@SerStack)
  Cognew(Drive,@DriveStack)
  
   
  repeat                           
                              
     GetSer
     Drive                                                         
     
     WheelAngle                                      'Wheel Angle for steering
     Transmitter                            'Transmit values     

     
PUB InitA
          
    SERVO.Set(7,1400)                                   'Initialize ESC's

PUB GetSer

    repeat
      rxHeight := SerCog
      rxWidth := SerCog
      rxTurretR := SerCog 
      rxTurretL := SerCog
      rxSteerR := SerCog      
      rxSteerL := SerCog
      rxDriveR := SerCog
      rxDriveF := SerCog
    return     

PUB Transmitter

    serial.dec(rxHeight) 
    serial.tx(13) 
    serial.dec(rxWidth) 
    serial.tx(13) 
    serial.dec(rxTurretR) 
    serial.tx(13)
    serial.dec(rxTurretL) 
    serial.tx(13) 
    serial.dec(rxSteerR) 
    serial.tx(13)
    serial.dec(rxSteerL) 
    serial.tx(13)
    serial.dec(rxDriveR) 
    serial.tx(13)
    serial.dec(rxDriveF) 
    serial.tx(13)
    
PUB WheelAngle

    IF rxSteerL == 1                              'If value is 1 turn right
      SERVO.SetRamp(ServoCh3,1000,70)
      SERVO.SetRamp(ServoCh1,2000,300)
    IF rxSteerR == 1
      SERVO.SetRamp(ServoCh3,1900,70)
      SERVO.SetRamp(ServoCh1,1000,300)            'If value is 1 turn left
    IF rxSteerR == 0 and rxSteerL == 0            'If value is 0 no turn 
      SERVO.SetRamp(ServoCh3,1425,70)
      SERVO.SetRamp(ServoCh1,1400,300)
    
 '   SERVO.SetRamp(ServoCh2,Tilt,100)           'Set servo movement with variables
           
PUB Drive

    Repeat 
      IF rxDriveF == 1
        SERVO.SetRamp(MotorChA,1370,300)
        repeat 5000000           'Initialize ESC A          
  '      SERVO.SetRamp(MotorChB,1425)           'Initialize ESC B
      IF rxDriveF == 0   
        SERVO.SetRamp(MotorChA,1400,300)           'Initialize ESC A          
        repeat 5000000 
  '      SERVO.SetRamp(MotorChB,1400)           'Initialize ESC B
      IF rxDriveR == 1   
        SERVO.SetRamp(MotorChA,1420,300)           'Initialize ESC A          
        repeat 5000000 
  '      SERVO.SetRamp(MotorChB,1370)           'Initialize ESC B
      IF rxDriveR == 0   
        SERVO.SetRamp(MotorChA,1400,300)           'Initialize ESC A          
        repeat 5000000 
  '      SERVO.SetRamp(MotorChB,1400)           'Initialize ESC B
  
        
          
                                                 'Pulsewidth #1400 is 0% duty
                                                 '    "      #1500 is 100% forward
                                                 '    "      #1300 is 100% reverse
PUB SerCog 

    rxVal_1 := serial.rx                        'Get next value from roborealm
    rxVal_2 := serial.rx 
    rxVal_3 := serial.rx 
    rxVal_4 := serial.rx 
    
    rxVal := rxVal_1 | (rxVal_2<<8) | (rxVal_3<<16) | (rxVal_4<<24)
    
    RETURN rxVal
{
\\[IMAGE_HEIGHT]\\[IMAGE_WIDTH]\\[NV_TURRET_LEFT]\\[NV_RIGHT]\\[NV_LEFT]\\[NV_BACKWARDS]\\[NV_FORWARD]
}                 